#include "StdAfx.h"
#include <varargs.h>

void logf(char *msg, ...);


myIDDraw1::myIDDraw1(LPDIRECTDRAW pOriginal)
{
	logf("myIDDraw1 Constructor");
	m_pIDDraw = pOriginal;
}


myIDDraw1::~myIDDraw1(void)
{
	logf("myIDDraw1 Destructor");
}


HRESULT __stdcall myIDDraw1::QueryInterface (REFIID a, LPVOID FAR * b)
{
	char *iid = "?";
	if (a == IID_IDirectDraw) iid = "IID_IDirectDraw";
	if (a == IID_IDirectDraw2) iid = "IID_IDirectDraw2";
	if (a == IID_IDirectDraw4) iid = "IID_IDirectDraw4";
	if (a == IID_IDirectDraw7) iid = "IID_IDirectDraw7";

	logf("myIDDraw1::QueryInterface(%s,%08x)",iid,b);
	

	*b = NULL;

	// call this to increase AddRef at original object
	// and to check if such an interface is there

	HRESULT hRes = m_pIDDraw->QueryInterface(a, b); 

	if (hRes == NOERROR) // if OK, send our "fake" address
	{
		*b = new myIDDraw2((LPDIRECTDRAW2)*b);
	}
	
	return hRes;
}


ULONG   __stdcall myIDDraw1::AddRef(void)
{
	logf("myIDDraw1::AddRef");
	return(m_pIDDraw->AddRef());
}


ULONG   __stdcall myIDDraw1::Release(void)
{
	logf("myIDDraw1::Release");
	
	// call original routine
	ULONG count = m_pIDDraw->Release();
	
	logf("Object Release."); 

    // in case no further Ref is there, the Original Object has deleted itself
	// so do we here
	if (count == 0) 
	{
		m_pIDDraw = NULL;		
		delete(this); 
	}

	return(count);
}


HRESULT  __stdcall myIDDraw1::Compact(void)
{
	logf("myIDDraw1::Compact");
	return(m_pIDDraw->Compact());
}


HRESULT  __stdcall myIDDraw1::CreateClipper(DWORD a, LPDIRECTDRAWCLIPPER FAR* b, IUnknown FAR* c)
{
	logf("myIDDraw1::CreateClipper");
	return(m_pIDDraw->CreateClipper(a, b, c));
}


HRESULT  __stdcall myIDDraw1::CreatePalette(DWORD a, LPPALETTEENTRY b, LPDIRECTDRAWPALETTE FAR* c, IUnknown FAR* d)
{
	HRESULT r = m_pIDDraw->CreatePalette(a, b, c, d);
	*c = new myIDDrawPalette(*c);
	logf("myIDDraw1::CreatePalette(%d,%08x,%08x,%08x) return %d",a,b,c,d,r);
	return r;
}


HRESULT  __stdcall myIDDraw1::CreateSurface(LPDDSURFACEDESC a, LPDIRECTDRAWSURFACE FAR* b, IUnknown FAR* c)
{
	HRESULT r = m_pIDDraw->CreateSurface(a, b, c);
	logf("myIDDraw1::CreateSurface([%d,0x%x,%d,%d,%d,%d,%d], %08x, %08x) return %d", a->dwSize, a->dwFlags, a->dwWidth, a->dwHeight, a->lPitch, a->dwBackBufferCount, a->ddsCaps, b, c, r); 

	*b = new myIDDrawSurface1(*b);
	
	return r;
}


HRESULT  __stdcall myIDDraw1::DuplicateSurface(LPDIRECTDRAWSURFACE a, LPDIRECTDRAWSURFACE FAR* b)
{
	logf("myIDDraw1::DuplicateSurface");
	return(m_pIDDraw->DuplicateSurface(a, b));
}


HRESULT  __stdcall myIDDraw1::EnumDisplayModes(DWORD a, LPDDSURFACEDESC b, LPVOID c, LPDDENUMMODESCALLBACK d)
{
	logf("myIDDraw1::EnumDisplayModes");
	return(m_pIDDraw->EnumDisplayModes(a, b, c, d));
}


HRESULT  __stdcall myIDDraw1::EnumSurfaces(DWORD a, LPDDSURFACEDESC b, LPVOID c, LPDDENUMSURFACESCALLBACK d)
{
	logf("myIDDraw1::EnumSurfaces");
	return(m_pIDDraw->EnumSurfaces(a, b, c, d));
}


HRESULT  __stdcall myIDDraw1::FlipToGDISurface(void)
{
	logf("myIDDraw1::FlipToGDISurface");
	return(m_pIDDraw->FlipToGDISurface());
}


HRESULT  __stdcall myIDDraw1::GetCaps(LPDDCAPS a, LPDDCAPS b)
{
	logf("myIDDraw1::GetCaps(%08x, %08x)", a, b);
	HRESULT r = m_pIDDraw->GetCaps(a, b);
	if (a)
	{
		logf("surface caps: %d %d %d %d %d %d %d %d",
		a->dwSize, a->dwCaps, a->dwCaps2, a->dwCKeyCaps, a->dwPalCaps, a->dwVidMemTotal,
		a->dwVidMemFree, a->ddsCaps.dwCaps);
	}
	if (b)
	{
		logf("HEL caps: %d %d %d %d %d %d %d %d",
		b->dwSize, b->dwCaps, b->dwCaps2, b->dwCKeyCaps, b->dwPalCaps, b->dwVidMemTotal,
		b->dwVidMemFree, b->ddsCaps.dwCaps);
	}
	return r;
}


HRESULT  __stdcall myIDDraw1::GetDisplayMode(LPDDSURFACEDESC a)
{
	logf("myIDDraw1::GetDisplayMode");
	return(m_pIDDraw->GetDisplayMode(a));
}


HRESULT  __stdcall myIDDraw1::GetFourCCCodes(LPDWORD a, LPDWORD b)
{
	logf("myIDDraw1::GetFourCCCodes");
	return(m_pIDDraw->GetFourCCCodes(a, b));
}


HRESULT  __stdcall myIDDraw1::GetGDISurface(LPDIRECTDRAWSURFACE FAR * a)
{
	logf("myIDDraw1::GetGDISurface");
	return(m_pIDDraw->GetGDISurface(a));
}


HRESULT  __stdcall myIDDraw1::GetMonitorFrequency(LPDWORD a)
{
	logf("myIDDraw1::GetMonitorFrequency");
	return(m_pIDDraw->GetMonitorFrequency(a));
}


HRESULT  __stdcall myIDDraw1::GetScanLine(LPDWORD a)
{
	logf("myIDDraw1::GetScanLine");
	return(m_pIDDraw->GetScanLine(a));
}


HRESULT  __stdcall myIDDraw1::GetVerticalBlankStatus(LPBOOL a)
{
	logf("myIDDraw1::GetVerticalBlankStatus");
	return(m_pIDDraw->GetVerticalBlankStatus(a));
}


HRESULT  __stdcall myIDDraw1::Initialize(GUID FAR* a)
{
	logf("myIDDraw1::Initialize");
	return(m_pIDDraw->Initialize(a));
}


HRESULT  __stdcall myIDDraw1::RestoreDisplayMode(void)
{
	logf("myIDDraw1::RestoreDisplayMode");
	return(m_pIDDraw->RestoreDisplayMode());
}


HRESULT  __stdcall myIDDraw1::SetCooperativeLevel(HWND a, DWORD b)
{

	HRESULT h = m_pIDDraw->SetCooperativeLevel(a, b); 

	logf("myIDDraw1::SetCooperativeLevel(%08x, %d) return %d", a, b, h);
	
	return(h);
}


HRESULT  __stdcall myIDDraw1::SetDisplayMode(DWORD a, DWORD b, DWORD c)
{
	HRESULT h = m_pIDDraw->SetDisplayMode(a, b, c);

	logf("myIDDraw1::SetDisplayMode(%d, %d, %d) return %d",a,b,c,h);
	
	return(h); 
}


HRESULT  __stdcall myIDDraw1::WaitForVerticalBlank(DWORD a, HANDLE b)
{
	logf("myIDDraw1::WaitForVerticalBlank");
	return(m_pIDDraw->WaitForVerticalBlank(a, b));
}


