#include "StdAfx.h"
#include <varargs.h>

void logf(char *msg, ...);


myIDDrawPalette::myIDDrawPalette(LPDIRECTDRAWPALETTE pOriginal)
{
	logf("myIDDrawPalette Constructor");
	m_pIDDrawPalette = pOriginal;
}


myIDDrawPalette::~myIDDrawPalette(void)
{
	logf("myIDDrawPalette Destructor");
}


HRESULT __stdcall myIDDrawPalette::QueryInterface (REFIID, LPVOID FAR * b)
{
	logf("myIDDrawPalette::QueryInterface");
	
	*b = NULL;

	return E_NOTIMPL;
}


ULONG   __stdcall myIDDrawPalette::AddRef(void)
{
	logf("myIDDrawPalette::AddRef");
	return(m_pIDDrawPalette->AddRef());
}


ULONG   __stdcall myIDDrawPalette::Release(void)
{
	logf("myIDDrawPalette::Release");
	
	// call original routine
	ULONG count = m_pIDDrawPalette->Release();
	
	logf("Object Release."); 

    // in case no further Ref is there, the Original Object has deleted itself
	// so do we here
	if (count == 0) 
	{
		m_pIDDrawPalette = NULL;		
		delete(this); 
	}

	return(count);
}



HRESULT  __stdcall myIDDrawPalette::GetCaps(LPDWORD a)
{
	logf("myIDDrawPalette::GetCaps");
	return m_pIDDrawPalette->GetCaps(a);
}



HRESULT  __stdcall myIDDrawPalette::GetEntries(DWORD a,DWORD b,DWORD c,LPPALETTEENTRY d)
{
	logf("myIDDrawPalette::GetEntries");
	return m_pIDDrawPalette->GetEntries(a,b,c,d);
}



HRESULT  __stdcall myIDDrawPalette::Initialize(LPDIRECTDRAW a, DWORD b, LPPALETTEENTRY c)
{
	logf("myIDDrawPalette::Initialize");
	return m_pIDDrawPalette->Initialize(((myIDDrawInterface*)a)->getAsDirectDraw(),b,c);
}



HRESULT  __stdcall myIDDrawPalette::SetEntries(DWORD a,DWORD b,DWORD c,LPPALETTEENTRY d)
{
	logf("myIDDrawPalette::SetEntries(%d,%d,%d,%08x)",a,b,c,d);
	return m_pIDDrawPalette->SetEntries(a,b,c,d);
}



